Index: /pjproject/trunk/aconfigure
===================================================================
--- /pjproject/trunk/aconfigure	(revision 2969)
+++ /pjproject/trunk/aconfigure	(revision 2970)
@@ -11501,4 +11501,8 @@
 _ACEOF
 
+			cat >>confdefs.h <<\_ACEOF
+#define PJ_HAS_SSL_SOCK 1
+_ACEOF
+
 		else
 			{ echo "$as_me:$LINENO: result: ** OpenSSL libraries not found, disabling SSL support **" >&5
Index: /pjproject/trunk/aconfigure.ac
===================================================================
--- /pjproject/trunk/aconfigure.ac	(revision 2969)
+++ /pjproject/trunk/aconfigure.ac	(revision 2970)
@@ -760,4 +760,5 @@
 	        	AC_MSG_RESULT([OpenSSL library found, SSL support enabled])
 			AC_DEFINE(PJSIP_HAS_TLS_TRANSPORT, 1)
+			AC_DEFINE(PJ_HAS_SSL_SOCK, 1)
 		else
 			AC_MSG_RESULT([** OpenSSL libraries not found, disabling SSL support **])
Index: /pjproject/trunk/pjlib/build/Makefile
===================================================================
--- /pjproject/trunk/pjlib/build/Makefile	(revision 2969)
+++ /pjproject/trunk/pjlib/build/Makefile	(revision 2970)
@@ -27,5 +27,5 @@
 	pool.o pool_buf.o pool_caching.o pool_dbg.o rand.o \
 	rbtree.o sock_common.o sock_qos_common.o sock_qos_bsd.o \
-	string.o timer.o types.o
+	ssl_sock_common.o ssl_sock_ossl.o string.o timer.o types.o
 export PJLIB_CFLAGS += $(_CFLAGS)
 
@@ -38,5 +38,5 @@
 		    ioq_unreg.o ioq_tcp.o \
 		    list.o mutex.o os.o pool.o pool_perf.o rand.o rbtree.o \
-		    select.o sleep.o sock.o sock_perf.o \
+		    select.o sleep.o sock.o sock_perf.o ssl_sock.o \
 		    string.o test.o thread.o timer.o timestamp.o \
 		    udp_echo_srv_sync.o udp_echo_srv_ioqueue.o \
Index: /pjproject/trunk/pjlib/build/cacert.pem
===================================================================
--- /pjproject/trunk/pjlib/build/cacert.pem	(revision 2970)
+++ /pjproject/trunk/pjlib/build/cacert.pem	(revision 2970)
@@ -0,0 +1,21 @@
+-----BEGIN CERTIFICATE-----
+MIIDXzCCAkegAwIBAgIJAPqAwYU5OQLXMA0GCSqGSIb3DQEBBQUAMEYxCzAJBgNV
+BAYTAkFVMRMwEQYDVQQIDApTb21lLVN0YXRlMQ4wDAYDVQQKDAVwanNpcDESMBAG
+A1UEAwwJcGpzaXAubGFiMB4XDTA5MTAyMjE3MTczN1oXDTE5MTAyMDE3MTczN1ow
+RjELMAkGA1UEBhMCQVUxEzARBgNVBAgMClNvbWUtU3RhdGUxDjAMBgNVBAoMBXBq
+c2lwMRIwEAYDVQQDDAlwanNpcC5sYWIwggEiMA0GCSqGSIb3DQEBAQUAA4IBDwAw
+ggEKAoIBAQDWWvnL+oSC0Q6OwGLt2YuhXTEzIVv3B+SGQ7tajB6H3WXVeq+1NmU9
+Yzca33g4FRrU7n4smYmKLzm1aniBhNmJjA+t+gbyizKnLMaCLoG52tUoULcANGKU
+aGwlmvZFugDn2eVg6UfUfRzEGbV3q3a/PzSsOEPwsMeF3YMQJPhkoyPQLtWgUXgP
+89Nyq3XjGGtw/qmUgQjE8a6/P0yXc+myI0hmApmZ9nB3YmlB5W3q6WoU2gGhLXf4
+12rH/LgdnPhM4ijS554Kv9EcUDdQTTrm6bYg66tj+qTet7DolUOlTZ3vKpuCK3tt
+eK9CbNPVzsMsB3yCALSLzQ347pIwfLaJAgMBAAGjUDBOMB0GA1UdDgQWBBRE/VNp
+kNQmLEXKQ+NM4bOVj95zYTAfBgNVHSMEGDAWgBRE/VNpkNQmLEXKQ+NM4bOVj95z
+YTAMBgNVHRMEBTADAQH/MA0GCSqGSIb3DQEBBQUAA4IBAQCj/gzJKTOZDEBD+zr7
+lvbVctiYE9o8ObxZQsnl/6zI2V9H/2yc1sqQyjBupzw6c37ehvk30yIyUfD3ts87
+2xaJ5VgtgUI3FI5DQ+ASyQXmDawUEmXIGqHb2gDrXBQLd6uMpvNDNW+7TouuniyA
+F12JUCNITeXaVJ0c8d4A9J9DlszBfYUzI45yIQu1gbpnpH74Sp/hG77EMxrRau+x
+EFFmV7gAmkCgOBnXm8jTKqNre/GfLfO7w2xoLsubSLnK46U3iLGBIJJRVGu3UQuN
+k1o7CiIKf0SSWj1bQI99ipTj8obBKRqj1nSbgKF/U6FIfd8DGcVvbJCSAG2czzyA
+5tdA
+-----END CERTIFICATE-----
Index: /pjproject/trunk/pjlib/build/pjlib.dsp
===================================================================
--- /pjproject/trunk/pjlib/build/pjlib.dsp	(revision 2969)
+++ /pjproject/trunk/pjlib/build/pjlib.dsp	(revision 2970)
@@ -354,4 +354,12 @@
 # Begin Source File
 
+SOURCE=..\src\pj\ssl_sock_common.c
+# End Source File
+# Begin Source File
+
+SOURCE=..\src\pj\ssl_sock_ossl.c
+# End Source File
+# Begin Source File
+
 SOURCE=..\src\pj\string.c
 # End Source File
@@ -603,4 +611,8 @@
 
 SOURCE=..\include\pj\sock_select.h
+# End Source File
+# Begin Source File
+
+SOURCE=..\include\pj\ssl_sock.h
 # End Source File
 # Begin Source File
Index: /pjproject/trunk/pjlib/build/pjlib.vcproj
===================================================================
--- /pjproject/trunk/pjlib/build/pjlib.vcproj	(revision 2969)
+++ /pjproject/trunk/pjlib/build/pjlib.vcproj	(revision 2970)
@@ -5644,4 +5644,12 @@
 					/>
 				</FileConfiguration>
+			</File>
+			<File
+				RelativePath="..\src\pj\ssl_sock_common.c"
+				>
+			</File>
+			<File
+				RelativePath="..\src\pj\ssl_sock_ossl.c"
+				>
 			</File>
 			<File
@@ -11639,4 +11647,8 @@
 			</File>
 			<File
+				RelativePath="..\include\pj\ssl_sock.h"
+				>
+			</File>
+			<File
 				RelativePath="..\include\pj\string.h"
 				>
Index: /pjproject/trunk/pjlib/build/pjlib_test.dsp
===================================================================
--- /pjproject/trunk/pjlib/build/pjlib_test.dsp	(revision 2969)
+++ /pjproject/trunk/pjlib/build/pjlib_test.dsp	(revision 2970)
@@ -75,5 +75,5 @@
 LINK32=link.exe
 # ADD BASE LINK32 kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib /nologo /subsystem:console /debug /machine:I386 /pdbtype:sept
-# ADD LINK32 netapi32.lib mswsock.lib ws2_32.lib kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib /nologo /subsystem:console /debug /machine:I386 /out:"../bin/pjlib-test-i386-win32-vc6-debug.exe" /pdbtype:sept
+# ADD LINK32 netapi32.lib mswsock.lib ws2_32.lib kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib  libeay32MT.lib ssleay32MT.lib /nologo /subsystem:console /debug /machine:I386 /out:"../bin/pjlib-test-i386-win32-vc6-debug.exe" /pdbtype:sept
 
 !ENDIF 
@@ -191,4 +191,8 @@
 
 SOURCE="..\src\pjlib-test\sock_perf.c"
+# End Source File
+# Begin Source File
+
+SOURCE="..\src\pjlib-test\ssl_sock.c"
 # End Source File
 # Begin Source File
